<template>
  <v-time-picker
    :title="title"
    :model-value="model"
    :color="color"
    :disabled="disabled"
    :format="format"
    :ampm-in-title="format === 'ampm'"
    border
    rounded="lg"
    @update:model-value="update"
  >
    <template v-if="actions" #actions>
      <slot name="actions" />
    </template>
  </v-time-picker>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue'

const emit = defineEmits(['update:modelValue'])

onMounted(() => {
  model.value = props?.modelValue
})

const model = ref(null)

const props = defineProps({
  modelValue: {
    type: String,
    default: undefined,
  },
  color: {
    type: String,
    default: 'primary',
  },
  title: {
    type: String,
    default: 'Select time',
  },
  actions: {
    type: Boolean,
    default: false,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  format: {
    type: undefined,
    default: 'ampm',
  },
})

const update = value => {
  emit('update:modelValue', value)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue
  }
})
</script>
